//
//
//
$(document).ready(function() {

    // JavaScript for reviews and ratings

    // Just grab the hidden context the once for the page...
    var hiddenContext = $("#hiddenContext").text(),
        actionUrl     = hiddenContext + "/commenting/comments/user-comments.action",
        flagUrl       = hiddenContext + "/commenting/comments/flag",
        moderateUrl   = hiddenContext + "/commenting/comments/moderate",
        rateUrl       = hiddenContext + "/commenting/comments/rate",
        recommendUrl  = hiddenContext + "/commenting/comments/recommend",
        showFormUrl   = hiddenContext + "/commenting/showcommentsform",
        stdTimeout    = 90000,
        publishButtonText = $("#comment_button_submit").text(),
        closeButtonText   = $("#comment_button_close").text();

    // Define the main messages...
    var MSG_FAIL_FORM_1      = "There has been an error whilst trying to submit your comment/reply: ",
        MSG_FAIL_ADD_1       = "Comment feedback (Add comment) failed: ",
        MSG_FAIL_APPROVAL_1  = "Comment feedback (Approval) failed: ",
        MSG_FAIL_REJECTION_1 = "Comment feedback (Rejection) failed: ",
        MSG_FAIL_RECOMMEND_1 = "Comment feedback (Recommend) failed: ",
        MSG_FAIL_FLAG_1      = "Comment feedback (Flag) failed: ",
        MSG_FAIL_REPLY_1     = "Comment feedback (Reply) failed: ",
        MSG_FAIL_RATING_1    = "Rating feedback failed: ",
        MSG_FAIL_REPLY_2     = "An error occurred while retrieving previous comments ",
        MSG_COMMENTFORM_0    = "Please enter a comment before submitting...",
        MSG_COMMENTFORM_1    = "Thank you for your submission. As a moderated list your submission requires approval before it will appear.",
        MSG_COMMENTFORM_2    = "Thank you for your submission. It should appear shortly.",
        MSG_COMMENTFORM_3    = " Please wait while the page is refreshed.";

    var commentFormDialogCreated = false;
    function createCommentFormDialog() {
        var commentForm = $("#commentForm");
        if (commentFormDialogCreated) {
            return commentForm;
        }
        commentForm.dialog({
            autoOpen: false,
            height: 600,
            width: 550,
            modal: true,
            title: "Add Comment/Reply",
            buttons: [{
                text: publishButtonText,
                click: function(e) {
                    var btnTarget = $(e.target).closest("button");
                    btnTarget.addClass("hideMe");
                    // Get the form details...
                    var form = $("#addCommentForm"),
                        url = form.attr("action"),
                        moderated = form.find("#moderated").attr("value"),
                        data = {},
                        respMsg = "";
    
                    $(":input", this).each(function(index) {
                        var here = $(this),
                            key = here.attr("name"),
                            val = here.val();
                        data[key] = val;
                    });
                    // Check for blank comment...
                    if (form.valid()) {
                    	function addComment() {
                            $.ajax({
                                type: "POST",
                                url: url,
                                data: data,
                                datatype: "text",
                                success: function(resp, statusText) {
                                    // It would appear that nothing is actually returned,
                                    // but let's assume success...
                                    respMsg = moderated === "true" ? MSG_COMMENTFORM_1 : MSG_COMMENTFORM_2;
                                },
                                error: function(req, statusText) {
                                    respMsg = MSG_FAIL_FORM_1 + statusText;
                                },
                                complete: function(req, statusText) {
                                    var redirectUrl;
                                    if (moderated === "false") {
                                        respMsg = respMsg + MSG_COMMENTFORM_3;
                                    }
                                    form.hide();
                                    $("#formResponse").addClass("commentSubmitted").text(respMsg);
                                    // Hide this button...
                                    btnTarget.addClass("hideMe").unbind();
                                    // Pass focus to the next [Close] button...
                                    btnTarget.next().focus();
                                    redirectUrl = window.location.href;
                                    if (redirectUrl.indexOf("activetab") === -1) {
                                        redirectUrl = redirectUrl + "?activetab=comments";
                                    }
                                    window.location.href = redirectUrl;
                                }
                            });
                    	}
                        if (typeof form.get(0).checkRecaptcha != 'undefined') {
                        	form.get(0).checkRecaptcha(addComment, function() {btnTarget.removeClass("hideMe");});
                        } else {
                        	addComment();
                        }
                    } else {
                        btnTarget.removeClass("hideMe");
                    }
                }
            },
            {
                text: closeButtonText,
                click: function(e) {
                    // Simply close the dialog box
                    commentForm.dialog("close");
                }
            }]
        });
    
        // Remove contents as the dialog is closed
        commentForm.bind("dialogbeforeclose", function(e) {
            commentForm.find("#userComment_text").remove();
            $("#formResponse").remove();
        });
        commentFormDialogCreated = true;
        return commentForm;
    }

    $(".commentform-field-required").each(function(index) {
        $(this).rules("add", {
            required: true,
            messages: {
                required: $("#required_field").html()
            }
        });
    });

    $(document).on("click", "#addAComment", function(e){
        var itemId = escape($("#itemIdForComment").text()),
            url = showFormUrl + "?item=" + itemId + "&pitem=" +itemId;
        $.ajax({
            type: "GET",
            url: url,
            cache: false,
            datatype: "html",
            success: function(resp, statusText) {
                $("#commentForm").html(resp);
                if (typeof registerRuntimeRecaptchas != 'undefined') {
                   registerRuntimeRecaptchas();
                }
            },
            error: function(req, statusText) {
                alert(MSG_FAIL_ADD_1 + statusText);
            }
        });
        createCommentFormDialog().dialog("open");
        $("#userComment_text").focus();
        return false;
    });

    $(document).on("click", 'a[id|="commentApprove"]', function(e) {
        var here = $(this),
            commentUUID,
            statusId,
            resultId,
            fullId = this.id,
            respMsg,
            startIndex = fullId.lastIndexOf("-"),
            commentId = fullId.substring(startIndex + 1),
            data = {"userComment.status": "Approved",
                    "userComment.id": commentId},
            url = moderateUrl;
        $.ajax({
            type: "POST",
            url: url,
            data: data,
            datatype: "text",
            timeout: stdTimeout,
            success: function(resp, statusText) {
                commentUUID = commentId.substring(commentId.lastIndexOf("/") + 1, commentId.length);
                statusId = "#status-" + commentUUID;
                resultId = "#result-" + commentUUID;
                if (resp.success) {
                    respMsg = $("#commenting_success").html();
                    $(resultId).html(respMsg);
                    $(statusId).text("Approved").addClass("commentApproved");
                }
             },
             error: function(req, statusText) {
                alert(MSG_FAIL_APPROVAL_1 + statusText);
             }
       });
       return false;
    });

    $(document).on("click", 'a[id|="commentReject"]',function(e) {
        var here = $(this),
            commentUUID,
            statusId,
            resultId,
            fullId = this.id,
            respMsg,
            startIndex = fullId.lastIndexOf("-"),
            commentId = fullId.substring(startIndex + 1),
            data = {"userComment.status": "Rejected",
                    "userComment.id": commentId},
            url = moderateUrl;

        $.ajax({
            type: "POST",
            url: url,
            data: data,
            datatype: "text",
            timeout: stdTimeout,
            success: function(resp) {
                commentUUID = commentId.substring(commentId.lastIndexOf("/") + 1, commentId.length);
                statusId = "#status-" + commentUUID;
                resultId = '#result-' + commentUUID;
                if (resp.success) {
                    respMsg = $("#commenting_success").html();
                    $(resultId).html(respMsg);
                    $(statusId).text("Rejected").addClass("commentRejected");
                }
            },
            error: function(req, statusText) {
                alert(MSG_FAIL_REJECTION_1 + statusText);
            }
        });
       return false;
    });

    $(document).on("click", 'a[id|="recommend"]', function(e) {
        var here = $(this),
            commentUUID,
            statusId,
            resultId,
            recommendCountId,
            count,
            fullId = this.id,
            startIndex = fullId.lastIndexOf("-"),
            commentId = fullId.substring(startIndex + 1),
            isGuestAllowed = document.getElementById("recommendorflag.guestAllowed").innerHTML,
            data = {"feedback.ratedItem": commentId,
                    "feedback.liked":true,
                    "feedback.uniqueId":fullId,
                    "feedback.guestAllowed":isGuestAllowed},
            url = recommendUrl;

        $.ajax({
            type: "POST",
            url: url,
            data: data,
            datatype: "text",
            success: function(resp, statusText) {
                commentUUID = commentId.substring(commentId.lastIndexOf("/") + 1, commentId.length);
                resultId = "#result-" + commentUUID;
                recommendCountId = "#recommendedCount-" + commentUUID;
                count = resp.count;
                $(resultId).text("" + resp.message + "").addClass("recommendSubmitted");
                if ($(recommendCountId).length !== 0 && (count !== null && $(count).length !== 0)) {
                    $(recommendCountId).text("" + resp.count + "");
                }
            },
            error: function(req, statusText) {
                alert(MSG_FAIL_RECOMMEND_1 + statusText);
            }
        });
        return false;
    });

    $(document).on("click", 'a[id|="flagged"]', function(e) {
        var here = $(this),
            commentUUID,
            statusId,
            resultId,
            flaggedCountId,
            count,
            fullId = this.id,
            startIndex = fullId.lastIndexOf("-"),
            commentId = fullId.substring(startIndex + 1),
            isGuestAllowed = document.getElementById("recommendorflag.guestAllowed").innerHTML,
            data = {"feedback.ratedItem": commentId,
                    "feedback.flagged":true,
                    "feedback.uniqueId":fullId,
                    "feedback.guestAllowed":isGuestAllowed},
            url = flagUrl;

        $.ajax({
            type: "POST",
            url: url,
            data: data,
            datatype: "text",
            success: function(resp) {
                commentUUID = commentId.substring(commentId.lastIndexOf("/") + 1, commentId.length);
                resultId = "#result-" + commentUUID;
                flaggedCountId = "#flaggedCount-" + commentUUID;
                count = resp.count;
                $(resultId).text("" + resp.message + "").addClass("flagSubmitted");
                if ($(flaggedCountId).length !== 0 && (count !== null && $(count).length !== 0)) {
                    $(flaggedCountId).text("" + resp.count + "");
                }
            },
            error: function(req, statusText) {
                alert(MSG_FAIL_FLAG_1 + statusText);
            }
        });
        return false;
    });

    $(document).on("click", 'a[id|="addReply"]', function(e) {
        var here = $(this),
            fullId = this.id,
            startIndex = fullId.lastIndexOf("-"),
            itemId = fullId.substring(startIndex + 1),
            pItemId = escape($("#itemIdForComment").text()),
            url = showFormUrl + "?item=" + itemId + "&pitem=" + pItemId;

        $.ajax({
            type: "GET",
            url: url,
            datatype: "html",
            success: function(resp, statusText) {
                $("#commentForm").html(resp);
                if (typeof registerRuntimeRecaptchas != 'undefined') {
                   registerRuntimeRecaptchas();
                }
            },
            error: function(req, statusText) {
                alert(MSG_FAIL_REPLY_1 + statusText);
            }
        });
        createCommentFormDialog().dialog("open");
        return false;
    });

    $("a[id|='itemRating']").click(function(e) {
        var here = $(this),
            startIndex,
            commentId,
            rating,
            data,
            url,
            rateMe = false,
            temp = "TEMP",
            ratingFormat = $("#ratingFormat").text(),
            isGuestAllowed = $("input[id='feedback.guestAllowed']").val();


        $("#ratingResult").text("").show();
        temp = $("input[id|='feedback.rating']:checked").val();
        if (temp === null || temp === undefined) {
            alert("Please choose your rating", "User Rating", function() {
                return false;
            });
        } else {
            startIndex = temp.lastIndexOf("-");
            commentId = temp.substring(startIndex + 1);
            rating = temp.substring(0, startIndex);
            data = {
                "feedback.ratedItem": commentId,
                "feedback.rating":rating,
                "feedback.guestAllowed":isGuestAllowed,
                "feedback.uniqueId":commentId
            };
            url = rateUrl;

            $.ajax({
                type: "POST",
                url: url,
                data: data,
                timeout: stdTimeout,
                datatype: "text",
                success: function(resp, statusText) {
                    $("#ratingResult").text("" + resp.message + "").addClass("ratingSubmitted clearer").delay(3000).fadeOut();
                    switch (ratingFormat) {
                    case "star":
                        $("#currentStarRating").text(resp.avgRating);
                        if (resp.avgRating > 0) {
                            $(".star-rating-live a,.star").attr("title", "Current rating " + resp.avgRating + " out of 5");
                            $(".currentStarRating").show();
                            $(".noStarRating").hide();
                        } else {
                            $(".star-rating-live a,.star").removeAttr("title");
                            $(".currentStarRating").hide();
                            $(".noStarRating").show();
                        }
                        break;
                    default:
                        $("#currentRating").text("" + resp.avgRating + "");
                        break;
                    }
                },
                error: function(req, statusText) {
                    $("#ratingResult").text(MSG_FAIL_RATING_1 + statusText).addClass("ratingSubmitted clearer");
                },
                complete: function(req, statusText) {
                }
            });
        }
        return false;
    });

    // Send the user to the signin...
    $(document).on("click", ".loginPrompt .signinlink", function() {
        $(".item-signin .signinlink").trigger("click");
    });

    // AHAH call for Comments
    if ($("#replynode").size() > 0) {
        var here = $(this),
            itemId = $("#hiddenitemid").text(),
            adminItemId = $("#hiddenadminitemid").text(),
            data = {"itemId": itemId,
		    "adminItemId": adminItemId},
            url = actionUrl,
            fragment = "";

        $.ajax({
            type: "GET",
            url: url,
            data: data,
            datatype: "html",
            timeout: stdTimeout,
            success: function(resp, statusText) {
                // The response is an entire page, so we need to extract
                // the bits we need...
                fragment = $(".commentsAhahContainer", resp);
                if (typeof registerRuntimeRecaptchas != 'undefined') {
                   registerRuntimeRecaptchas();
                }
            },
            error: function(req, statusText, message) {
                fragment = "<p>" + MSG_FAIL_REPLY_2 + "(" + statusText + (message !== undefined ? " - " + message : "") + ")</p>";
            },
            complete: function(req, statusText) {
                $(".commentsloading").remove();
                $("#replynode").after(fragment);
            }
        });
    } 

    $(".addarticlerecommendation").click(function() {
        var itemId = $("#recommendItemId").text(),
    	isGuestAllowed = $("#recommendGuestAllowed").text();
	
        $.ajax({
            type: "POST",
            url: recommendUrl,
            data: {"feedback.ratedItem": itemId,
                "feedback.liked":true,
                "feedback.uniqueId":itemId + "Liked",
                "feedback.guestAllowed":isGuestAllowed
            	},
            timeout: stdTimeout,
            datatype: "text",
            success: function(resp, statusText) {
                $(".articleRecommendCount").text(resp.recommendedCount);
            	$(".youRecommendedThis").show();
            	$(".RecommendThis").hide();
            },
            error: function(req, statusText) {
                $("#ratingResult").text(MSG_FAIL_RATING_1 + statusText).addClass("ratingSubmitted clearer");
            },
            complete: function(req, statusText) {
            }
        });
	    return false;
    });
    
    $(".removearticlerecommendation").click(function() {
        var itemId = $("#recommendItemId").text(),
        	isGuestAllowed = $("#recommendGuestAllowed").text();

        $.ajax({
            type: "POST",
            url: recommendUrl,
            data: {"feedback.ratedItem": itemId,
                "feedback.liked":false,
                "feedback.uniqueId":itemId + "Liked",
                "feedback.guestAllowed":isGuestAllowed
                },
            timeout: stdTimeout,
            datatype: "text",
            success: function(resp, statusText) {
                        $(".articleRecommendCount").text(resp.recommendedCount);
                $(".youRecommendedThis").hide();
                $(".RecommendThis").show();
            },
            error: function(req, statusText) {
                $("#ratingResult").text(MSG_FAIL_RATING_1 + statusText).addClass("ratingSubmitted clearer");
            },
            complete: function(req, statusText) {
            }
        });
        return false;
    });

});