var USRApp = USRApp || {
    // Accepted media type details
    mediaDetails: {
        "aip-media-type-youtube": ["video", "youtube"],
        "aip-media-type-vimeo": ["video", "vimeo"],
        "aip-media-type-mp4": ["video", "video/mp4"],
        "aip-media-type-m4v": ["video", "video/mp4"],
        "aip-media-type-f4v": ["video", "video/mp4"],
        "aip-media-type-mov": ["video", "video/mp4"],
        "aip-media-type-flv": ["video", "video/flv"],
        "aip-media-type-webm": ["video", "video/webm"],
        "aip-media-type-aac": ["audio", "audio/mp4"],
        "aip-media-type-m4a": ["audio", "audio/mp4"],
        "aip-media-type-f4a": ["audio", "audio/mp4"],
        "aip-media-type-mp3": ["audio", "audio/mpeg"],
        "aip-media-type-ogg": ["audio", "audio/ogg"]
    },
    dialogHeights: {
        standardSize: "315",
        smallSize: "188",
        fullSize: "510"
    },
    dialogWidths: {
        standardSize: "420",
        smallSize: "250",
        fullSize: "680"
    },
    /**
     * Define video/audio details by class 
     */
    aipCreateMediaTags: function() {
        var count = 0;

        $("div.aip-embed-media").each(function (index) {
            var aipMediaCode = "",
                aipMedia = $(this),
                mediaSrc = aipMedia.text(),
                mediaWidth = USRApp.dialogWidths.standardSize,
                mediaHeight = USRApp.dialogHeights.standardSize,
                mimeType = "",
                fileType = "",
                playerId = "",
                classAlignment = "";

            // remove spaces if they occur within the source
            mediaSrc = mediaSrc.replace(/\s+/g, "");
            // alignment set through css default is left
            if (aipMedia.hasClass("aip-media-align-right")) {
                classAlignment = "aip-media-align-right";
            } else if (aipMedia.hasClass("aip-media-align-center")) {
                classAlignment = "aip-media-align-center";
            }
            // get size requirement
            if (aipMedia.hasClass("aip-media-size-small")) {
                mediaWidth = USRApp.dialogWidths.smallSize;
                mediaHeight = USRApp.dialogHeights.smallSize;
            } else if (aipMedia.hasClass("aip-media-size-full")) {
                mediaWidth = USRApp.dialogWidths.fullSize;
                mediaHeight = USRApp.dialogHeights.fullSize;
            }
            // checks classes to determine mime type and file type
            for (var key in USRApp.mediaDetails) {
                if (aipMedia.hasClass(key)) {
                    fileType = USRApp.mediaDetails[key][0];
                    mimeType = USRApp.mediaDetails[key][1];
                }
            }
            // if blank send warning
            if (fileType === "") {
                // non-accepted media type array insert after media info div
                if (!aipMedia.next().is("#mediaEmbedCode")) {
                    $("<div id='mediaEmbedCode'><a href='" + mediaSrc + "' title='Link to video'>" + mediaSrc + "</a></div>").insertAfter(this);
                } else {
                    aipMedia.next().html("<a href='" + mediaSrc + "' title='Link to video'>" + mediaSrc + "</a>");
                }
            }
            // else set it up
            if (fileType !== "" && mimeType !== "") {
                if (mimeType === "youtube") {
                    aipMediaCode = "<iframe src='" + mediaSrc + 
                                   "'width='" + mediaWidth + 
                                   "' height='" + mediaHeight + 
                                   "' frameborder='0' allowfullscreen></iframe>";

                    // insert after media info div
                    if (!aipMedia.next().is("#mediaEmbedCode")) {
                        $("<div id='mediaEmbedCode'>" + aipMediaCode + "</div>").insertAfter(this);
                    } else {
                        aipMedia.next().html(aipMediaCode);
                    }
                } else if (mimeType === "vimeo") {
                    aipMediaCode = "<iframe src='" + mediaSrc + 
                                   "' width='" + mediaWidth + 
                                   "' height='" + mediaHeight + 
                                   "' frameborder='0' webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>";

                    // insert after media info div
                    if (!aipMedia.next().is("#mediaEmbedCode")) {
                        $("<div id='mediaEmbedCode'>" + aipMediaCode + "</div>").insertAfter(this);
                    } else {
                        aipMedia.next().html(aipMediaCode);
                    }
                } else { //use JW player
                    playerId = "mediaEmbedCode" + count;
                    aipMediaCode = "<div id='" + playerId + "'></div>";
                    // insert after media info div
                    if (!aipMedia.next().is("#mediaEmbedCode")) {
                        $(aipMediaCode).insertAfter(this);
                    } else {
                        aipMedia.next().html(aipMediaCode);
                    }
                    count += 1;
                    jwplayer(playerId).setup({
                        file: mediaSrc,
                        width: mediaWidth,
                        height: mediaHeight,
                        fallback: false
                    });
                }
                // changes alignment if this is set
                if (classAlignment !== "") {
                    aipMedia.next("div[id^='mediaEmbedCode']").addClass(classAlignment);
                }
            }
        }); //end for each
    }
};

$(document).ready(function() {
	
	// create a click function for bespoke tab content side bar nav links 	
	$(".bespoketab-sidebar").on("click",function(){
		//alert("clicked");
		var elem = $(this).parent().find("li"); //.toggle();
		$(this).find("span").toggleClass("aip-icon-arrow-down4 aip-icon-arrow-up4");
		//if (elem.not(".active")){
			elem.not(".active").toggle();
		//}
	});
	
	/********************/
	
    // if this div exists create embed tag
    if ($("div.aip-embed-media").length) {
        USRApp.aipCreateMediaTags();
    }
    // whenever you edit, remove the media embed tag
    $("span.blurb-editor").click(function(e) {
        $("div[id^='mediaEmbedCode']").each(function(index) {
            $(this).remove();
        });
    });
    
   /********************/
    // ptol More about us click to show menu at mobile view
    $("#container").on("click",".aip-linked-content-dropdown-label",function(){
    	$(this).find("span").toggleClass("aip-icon-arrow-up4 aip-icon-arrow-down4");
    	$(".aip-left-side-linkset, .ptoldailyedition-linkset").toggle();
    });
    
    //js swap div list use link text i query url
    $(".aip-left-side-linkset li a").hover(function(e) {
        var $link = $(this),
            sectioName,
            newHref;
        
        sectionName= $link.attr('href');
        if (sectionName.indexOf('#') != -1){
        	//get information for link
        	sectionName= $link.text().trim();
        	sectionName = encodeURIComponent(sectionName);
        	newHref= document.location['pathname'] + "?section=" + sectionName;
        	//replace href for future use
        	$link.attr('href', newHref);        	
        	
        }
        // if it isn't an external link and linked content exists
       /* if (!$link.hasClass("aip-externaltab")) {	
        	//get information for link
        	sectionName= $link.text();
        	sectionName = encodeURIComponent(sectionName);
        	newHref= document.location['pathname'] + "?section=" + sectionName;
        	//replace href for future use
        	$link.attr('href', newHref);
        }*/
    });
    
    //if page loaded utilizes content-parts and query param open correct div
    if ($("#aip-linked-content-parts").length && document.location['search'].indexOf("?section=") >= 0) {                
        var sectionName =  document.location['search'].replace('?section=', ''),
        	idName = "";
        
        sectionName = decodeURIComponent(sectionName);
        
        $(".aip-left-side-linkset li a").each(function(){
        	if($(this).text().trim() == sectionName) {
        		idName = $(this).parent('li').prop('id');
        	}
        });

    	$("#aip-linked-content-parts").find(".aip-linked-content-part").each(function(index) {
            var $thisItem = $(this);
            
            if ($thisItem.hasClass(idName)) {
                $thisItem.show();
            } else {
                $thisItem.hide();
            }
        });
    	
	   if( idName == "" ){
    		//if no match was found redirect to 404
        	//res.status(404).render('error404')
        	var div404 = $('#sectionDoesNotExist').html();
        	
        	$('#aip-linked-content-parts').append(div404);
        	$('#aip-linked-content-parts .aip-user-section-missing').text(sectionName);
    	}
	    //this marks the selection sections link
	    $(".aip-left-side-linkset li").each(function(){
	            var $thisLi = $(this);

	            if ($thisLi.attr('id') == idName) {
	            	 $thisLi.css("font-weight","bold");
	            	 $thisLi.addClass("active");
	            } else {
	                $thisLi.css("font-weight","normal");
	                $thisLi.removeClass("active");
	            }
	    	});	    	 
    } else if ($("#aip-linked-content-parts").length && !document.location['search'].indexOf("?section=") >= 0) {
    	$(".aip-left-side-linkset li:first").each(function(){
            var $thisLi = $(this);
            $thisLi.css("font-weight","bold");
    	});
    }
    
    /********************/
    
    // Allow users to define external links
    // temporarily adding the email this link to this function until we can get dialog up
    $(document).on("click", ".aip-user-externallink, span.emailtext a", function(e) {
        var target = $(this).attr("href");
        window.open(target);
        e.stopImmediatePropagation();
        e.preventDefault();
        return false;
    });
    return false;
});
